#!/bin/bash
# EX.2019/12/4
# cpanel Fix Account Permissions
# https://github.com/PeachFlame/cPanel-fixperms
# https://www.thecpaneladmin.com/fix-account-permissions/
# 帳號備份檔，請放置 /backup/cpbackup/daily/account 目錄
# 執行此script之前，請先執行 find_sort_acccounts.sh 取得帳號列表
# 請於 /backup/cpbackup/daily/account 目錄執行此 script

# 如果需要統計還原時間，可以取消以下註解，以及底下log相關註解
#rm -f /root/all_time.txt
#rm -f /root/restore_log
#date >> /root/all_time.txt

filename="/backup/cpbackup/daily/big_account_list"
exec < $filename

while read line
do

# 帳號名稱
#echo "$line" >> /root/restore_log

# 將帳號備份homedir先移到/backup
mv /backup/cpbackup/daily/account/"$line"/homedir /backup

# 單一帳號還原 Start
#date >> /root/restore_log

# 執行帳號還原，忽略homedir資料夾還原
cd /backup/cpbackup/daily/account/
/scripts/restorepkg --force --disable=Homedir "$line"

# 單一帳號還原 End
#date >> /root/restore_log

# 使用rsync同步homedir
rsync -rvlHpDtP /backup/homedir/ /home/"$line"/

# 單一帳號rsync End
#date >> /root/restore_log

# 修正目錄與檔案權限
find /home/"$line"/public_html -type d -exec chmod 755 {} \;
find /home/"$line"/public_html -type f | xargs -d$'\n' -r chmod 644
find /home/"$line"/public_html -name '*.cgi' -o -name '*.pl' -o -name '*.perl' | xargs -r chmod 755

chown -R $line:$line /home/"$line"/
find /home/"$line" -name .htaccess -exec chown $line.$line {} \;

chown $line:nobody /home/"$line"/public_html
chown $line:nobody /home/"$line"/.htpasswds
chown $line:mail /home/"$line"/etc
chown $line:mail /home/"$line"/etc/*/passwd
chown $line:mail /home/"$line"/etc/*/quota
find /home/"$line"/etc -type d -exec chown $line:mail {} \;

chmod 750 /home/"$line"/public_html
chmod 750 /home/"$line"/public_ftp
chmod 711 /home/"$line"

chmod 771 /home/"$line"/.cagefs
chmod 700 /home/"$line"/.cagefs/opt
chmod 700 /home/"$line"/.cagefs/tmp
chmod 700 /home/"$line"/.cagefs/var

# 修正沒有放在 public_html 範圍內網站根目錄權限
for SUBDOMAIN in $(grep -i documentroot /var/cpanel/userdata/"$line"/* | grep -v '.cache\|_SSL' | awk '{print $2}' | grep -v public_html)
do
  find $SUBDOMAIN -type d -exec chmod 755 {} \;
  find $SUBDOMAIN -type f | xargs -d$'\n' -r chmod 644
  find $SUBDOMAIN -name '*.cgi' -o -name '*.pl' -o -name '*.perl' | xargs -r chmod 755

  chown -R $line:$line $SUBDOMAIN
  find $SUBDOMAIN -name .htaccess -exec chown $line.$line {} \;
  chmod 750 $SUBDOMAIN
  chown $line:nobody $SUBDOMAIN
done

# 修正放在 public_html 範圍內網站根目錄權限
for SUBDOMAIN in $(grep -i documentroot /var/cpanel/userdata/"$line"/* | grep -v '.cache\|_SSL' | awk '{print $2}' | grep public_html)
do
  chmod 750 $SUBDOMAIN
  chown $line:nobody $SUBDOMAIN
done

# 將帳號備份homedir移回原本位置
mv /backup/homedir /backup/cpbackup/daily/account/"$line"/

#echo "" >> /root/restore_log
#echo "===============" >> /root/restore_log
#echo "" >> /root/restore_log

done

# 如果需要統計還原時間，可以取消以下註解
#date >> /root/all_time.txt

